// PythonConsole.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <boost/python.hpp>
#include <boost/detail/lightweight_test.hpp>
#include <iostream>
#include "HelloWorld.h"

namespace python = boost::python;

void exec_mythma()
{
   std::cout << "exec extension module Mythma..." << std::endl;

   python::dict global;
   python::object result = python::exec_file(
      ".\\axxscript.py", global, global);


   python::object world = global["world"];
   CHelloWorld& py = python::extract<CHelloWorld&>(world) BOOST_EXTRACT_WORKAROUND;

   std::cout << py.GetId() << std::endl;

   std::cout << "success!" << std::endl;
}

int main(int argc, char **argv)
{
   // Initialize the interpreter
   Py_Initialize();

   if (python::handle_exception(exec_mythma))
   {
      if (PyErr_Occurred())
      {
         BOOST_ERROR("Python Error detected");
         PyErr_Print();
      }
      else
      {
         BOOST_ERROR("A C++ exception was thrown  for which "
            "there was no exception translator registered.");
      }
   }

   char ch;
   std::cin >> ch;
   // Boost.Python doesn't support Py_Finalize yet, so don't call it!
   return boost::report_errors();
}
